[PA-]
VERSION=23
FNAM=C:\Users\senso\Desktop\Matrix\Matrix - Display or Set utils\MX_exclu_mode.pat
NBPG=10
OFFSETX=-40
OFFSETY=60
COLOR=10149319
VISIBLEINIB=1
SHOWHINT=1
SHARED=1
PRESETISOLATED=0
CONDUCTORISOLATED=0
ENABLEUNDO=1
QIDX0=0
I0=1101C201F300F300
I1=A700810264016401
I2=A6000C01AE01AE01
I3=440009019D009D00
I4=0900170175007500
I5=03000D01E400E400
I6=0300070102010201
I7=03000A0131013101
I8=030004014F014F01
I9=0900050172017201
C0=0200000000000700
C1=0300010000000200
C2=0400010000000100
C3=0500010000000300
C4=0600010000000400
C5=0700010000000500
C6=0800010000000600
C7=0900010000000900
C8=0000080001000000
NBCO=9
use layout=1
background color=8421504
rounded=1
round size=7
show caption=1
caption color=10149319
caption font color=0
caption font size=16
caption font bold=0
caption font italic=0
caption font underline=0
auto resize=1
show border=1
border color=15658734
border width=4
show grid=0
grid size=2
show minimize button=1
minimized height=33
minimized width=134
show snapshot=0
VOn=1
MIDIMODE=0
IBPOS=0200020093009300
IBPOSVALID=1
IBMINIMIZED=0
GRIDMINIMIZED=0

[PA-0]
SCRIPTPROC=/////////////////////////////////////////////////////////////////////////////////////////////////,//,"// To be used with the Matrix user module to turn other cells as selected by the mode parameter:","//   - cell : only one cell on in the whole matrix","//   - column: only one cell on per column","//   - row: only one cell on per row","//   - col/row: mixture of ""column"" and ""row""",//,"// NOTE:","//   - Changing mode clears the matrix.","//   - With the matrix' mouse mode = ""draw"", this script doesn't work very well, but ""column""","//     and ""row"" might be useful despite the slightly weird behaviour.",//,"// bSork, March 2010",/////////////////////////////////////////////////////////////////////////////////////////////////,,"VAR pReset, pExcluMode, pNumCols, pNumRows, pLastCol, pLastRow, pArrIn, pArrOut, pMouseDown : tParameter;","VAR mode, numCols, numRows, lastCol, lastRow, lastIn : Integer;","VAR cols : ARRAY OF Integer;","VAR rows : ARRAY OF Integer;","VAR first, clicked : Boolean;",,"PROCEDURE Init;",BEGIN,"   pReset := CreateParam('reset', ptSwitch); SetIsOutput(pReset, FALSE);",,"   pExcluMode := CreateParam('exclu mode', ptListBox); SetIsOutput(pExcluMode, FALSE);","   SetListBoxString(pExcluMode, '""cell"",""column"",""row"",""col/row""');",,"   pNumCols := CreateParam('num of cols', ptDataFader); SetIsOutput(pNumCols, FALSE);","   SetFormat(pNumCols, '%.0f'); SetMin(pNumCols, 1); SetMax(pNumCols, 128);",,"   pNumRows := CreateParam('num of rows', ptDataFader); SetIsOutput(pNumRows, FALSE);","   SetFormat(pNumRows, '%.0f'); SetMin(pNumRows, 1); SetMax(pNumRows, 128);",,"   pLastCol := CreateParam('last click col', ptDataFader); SetIsOutput(pLastCol, FALSE);","   SetFormat(pLastCol, '%.0f');  SetMin(pLastCol, -1); SetMax(pLastCol, 127);",,"   pLastRow := CreateParam('last click row', ptDataFader); SetIsOutput(pLastRow, FALSE);","   SetFormat(pLastRow, '%.0f'); SetMin(pLastRow, -1); SetMax(pLastRow, 127);",,"   pArrIn := CreateParam('cells in', ptArray); SetIsOutput(pArrIn, FALSE);","   pArrOut := CreateParam('cells out', ptArray); SetIsInput(pArrOut, FALSE);",,"   pMouseDown := CreateParam('mouse down', ptSwitch); SetIsOutput(pMouseDown, FALSE);",,"   first := TRUE;","   clicked := FALSE;","END; // Init",,///////////////////////////////////////////////////////////////////////////////////////,,"PROCEDURE NewMode;","   VAR i : Integer;",BEGIN,"   mode := round(GetValue(pExcluMode));","   FOR i := 0 TO (numCols - 1) DO cols[i] := -1;","   FOR i := 0 TO (numRows - 1) DO rows[i] := -1;","   lastIn := -1;","   IF (NOT first) THEN","      FOR i := 0 TO (GetLength(pArrOut) - 1) DO","         SetDataArrayValue(pArrOut, i, 0.0);","END; // NewMode",,///////////////////////////////////////////////////////////////////////////////////////,,,"PROCEDURE DoUpdate;","   VAR newValue : Single;","   VAR lastClicked : Integer;",BEGIN,"   IF (lastCol >= 0) THEN BEGIN // clicking within the matrix module but not in a cell returns -1/-1","      lastClicked := lastRow * numCols + lastCol;","      newValue := GetDataArrayValue(pArrIn, lastClicked);","      IF (mode = 0) THEN BEGIN  // Single cell","         IF ((lastIn >= 0) AND (lastIn <> lastClicked)) THEN","            SetDataArrayValue(pArrOut, lastIn, 0.0);","         lastIn := lastClicked;","      END","      ELSE BEGIN","         IF ((mode = 1) OR (mode = 3)) THEN BEGIN // column or col/row","            IF (cols[lastCol] >= 0) THEN","               SetDataArrayValue(pArrOut, cols[lastCol] * numCols + lastCol, 0.0);","            cols[lastCol] := lastRow;","         END;","         IF ((mode = 2) OR (mode = 3)) THEN BEGIN // row or col/row","            IF (rows[lastRow] >= 0) THEN","               SetDataArrayValue(pArrOut, lastRow * numCols + rows[lastRow], 0.0);","            rows[lastRow] := lastCol;","         END;","      END;","      SetDataArrayValue(pArrOut, lastClicked, newValue);","   END;","   clicked := FALSE;","END; // DoUpdate",,///////////////////////////////////////////////////////////////////////////////////////,,"PROCEDURE Callback(n : Integer);","   VAR i : Integer;",BEGIN,"   CASE n OF","      pReset     : NewMode;","      ","      pExcluMode      : NewMode;","      ","      pNumCols   : BEGIN","                      numCols := round(GetValue(n));","                      SetArrayLength(cols, numCols);","                      IF (NOT first) THEN BEGIN","                         FOR i := 0 TO (numCols - 1) DO cols[i] := -1;","                         SetLength(pArrOut, numRows * numCols);","                      END;","                   END;","                   ","      pNumRows   : BEGIN","                      numRows := round(GetValue(n));","                      SetArrayLength(rows, numRows);","                      IF (NOT first) THEN BEGIN","                         FOR i := 0 TO (numRows - 1) DO rows[i] := -1;","                         SetLength(pArrOut, numRows * numCols);","                      END;","                   END;","                   ","      pLastCol   : lastCol := round(GetValue(n));","                   ","      pLastRow   : lastRow := round(GetValue(n));",,"      pArrIn     : clicked := TRUE;","      ","      pMouseDown : clicked := TRUE;","   END;","END; // Callback",,///////////////////////////////////////////////////////////////////////////////////////,,"PROCEDURE Process;",BEGIN,"   IF (clicked) THEN DoUpdate;","   IF (first) THEN BEGIN","      SetLength(pArrOut, numRows * numCols);","      NewMode;","      first := FALSE;","   END;",END;
PATH=
FNAME=E:\Audio\Usine Pro StandAlone 5.13beta\Files\Modules\Scripts\Empty Script.script
PRESETID=35608827
REMOTEID=
Vreset=0
INDEXexclu mode=0
Vnum of cols=5
Vnum of rows=7
Vlast click col=2
Vlast click row=4
Vmouse down=0
USERNAME=mx_exlusive_mode
FORMPOS=19056E0057023702

[PA-1]
PRESETID=13926947
REMOTEID=
Tcaption=cells out
INDEXprec=1

[PA-2]
PRESETID=13926948
REMOTEID=
TABdataV=00000000
TABdataL=1
Tcaption=cells in
INDEXprec=1

[PA-3]
PRESETID=35669291
REMOTEID=
INDEXvisible=1
INDEXlist=0
Tcaption=exclu mode
Ttext=cell
MIDIMODE=0
IBPOS=0800280086000E00
LIST=cell,column,row,col/row

[PA-4]
PRESETID=35794114
REMOTEID=
INDEXvisible=1
Vbutton=0
Tcaption=reset
Vcolor=783569
VOFF value=0
VON value=1
Vnull evt if OFF=0
INDEXgroup=0
Vat least one=0
MIDIMODE=0
IBPOS=0800180058000E00
ISLED=0

[PA-5]
PRESETID=35924341
REMOTEID=
INDEXvisible=1
Vfader=5
Vmin=1
Vmax=128
Tcaption=num of cols
Vcolor=15572898
INDEXprec=0
INDEXscale=0
Vdefault val=0
Vinc/dec val=1
Vauto reset=0
MIDIMODE=0
IBPOS=08003C0086000E00

[PA-6]
PRESETID=35927745
REMOTEID=
INDEXvisible=1
Vfader=7
Vmin=1
Vmax=128
Tcaption=num of rows
Vcolor=15572898
INDEXprec=0
INDEXscale=0
Vdefault val=0
Vinc/dec val=1
Vauto reset=0
MIDIMODE=0
IBPOS=08004C0086000E00

[PA-7]
PRESETID=35940462
REMOTEID=
INDEXvisible=1
Vfader=2
Vmin=-1
Vmax=127
Tcaption=last click col
Vcolor=15572898
INDEXprec=0
INDEXscale=0
Vdefault val=0
Vinc/dec val=1
Vauto reset=0
MIDIMODE=0
IBPOS=0800600086000E00

[PA-8]
PRESETID=35944271
REMOTEID=
INDEXvisible=1
Vfader=4
Vmin=-1
Vmax=127
Tcaption=last click row
Vcolor=15572898
INDEXprec=0
INDEXscale=0
Vdefault val=0
Vinc/dec val=1
Vauto reset=0
MIDIMODE=0
IBPOS=0800700086000E00

[PA-9]
PRESETID=35948205
REMOTEID=
INDEXvisible=1
Vbutton=0
Tcaption=mouse down
Vcolor=783569
VOFF value=0
VON value=1
Vnull evt if OFF=0
INDEXgroup=0
Vat least one=0
MIDIMODE=0
IBPOS=0800800058000E00
ISLED=0

